; THE CAVE ---- (c)2013 BY PSY
; http://PSY-LABS.COM

; Made for Blitzforum Minimalist Competition #1
; http://www.blitzforum.de/forum/viewtopic.php?t=39245&postdays=0&postorder=Asc&start=0
; THE CAVE is available @ http://pheryllt.de/_misc/blitzforum/TheCave-PSY-MinimalistCompo2013.rar


Graphics 640,480,16,1			; INITIALIZE GRAPHICS WITH 640x480 AND 16BIT FULLSCREEN. AS RETRO AS IT CAN BE :)																																
SetBuffer BackBuffer()

Type TObstacle					; THIS TYPE HANDLES ALL OBSTACLES. BASICALLY, ALL OBSTACLES ARE 1-COLOUR-BLOCKS WHICH REPRESENT DOORS
	Field x%, y%				; OBSTACLE X/Y POSITION ON A 640x480 SCREEN
	Field beatenBy%				; ITEM ID WHICH CAN BEAT THE OBSTACLE
	Field SX%, SY%				; OBSTACLE X/Y SCREEN ID (MAP CONSISTS OF 9x9 SCREENS)
	Field Destroyed%			; TRUE IF OBSTACLE HAS BEEN DESTROYED
	Field image%				; HANDLE OF OBSTACLE .PNG
End Type

Global obstacle.TObstacle

Type TItem						; THIS TYPE HANDLES ALL ITEMS. BASICALLY, ALL ITEMS ARE 1-COLOUR-BALLS WHICH REPRESENT KEYS
	Field x%, y%				; ITEM X/Y POSITION ON A 640x480 SCREEN
	Field SX%, SY%				; ITEM X/Y SCREEN ID (MAP CONSISTS OF 9x9 SCREENS)
	Field owned%				; ITEM CARRIED BY PLAYER?
	Field ID%					; ID FOR OBSTACLE (ITEM 1 CAN BEAT OBSTACLE 1 AND SO ON...)
	Field image%				; HANDLE OF ITEM .PNG
End Type

Global item.TItem



Local i%

Global Xscroll%	= 3													; SCREEN X ID (PLAYER STARTS AT 3/4)
Global Yscroll% = 4													; SCREEN Y ID
Global playerX% = 350												; PLAYER X POSITION ON CURRENT SCREEN
Global playerY% = 250												; PLAYER Y POSITION ON CURRENT SCREEN
Global cave% 	= LoadImage ("gfx/cave.bmp")						; LOADS THE CAVE LAYOUT
Global player	= LoadImage ("gfx/player.png")						; LOADS PLAYER GFX




; IN THE FOLLOWING LOOP, 5 ITEMS AND 5 OBSTACLES ARE CREATED
; ITEM 1 BEATS OBSTACLE 1, ITEM 2 BEATS OBSTACLE 2 AND SO ON
; DUE TO THE 256BYTE-LIMIT, ITEMS AND OBSTACLES RESPECTIVELY HAVE THE SAME X/Y POSITION ON A 640x480 SCREEN
; THE SCREEN, HOWEVER, IS DIFFERENT TO MAKE THEM HARDER TO FIND
; I'M EXPLOITING THE ACCURACY PROBLEM HERE WHICH OCCURS WHEN CASTING FLOATS --> INT(1*1.5) = 2.....INT(3*1.5) = 4
For i=1 To 5														
	item.TItem			= New TItem									
	item\ID 			= i											
	item\x 				= 260										; X POSITION ON SCREEN
	item\y 				= 160										; Y POSITION ON SCREEN
	item\SX 			= i * 1.5									; X SCREEN WHERE THE ITEM WILL SPAWN
	item\SY 			= i + 3										; Y SCREEN WHERE THE ITEM WILL SPAWN
	item\image			= LoadImage("gfx/item" + i + ".png")		; LOADS ITEM GFX
	
	obstacle.TObstacle	= New TObstacle								
	obstacle\beatenBy	= i											; OBSTACLE(I) IS BEATEN BY ITEM(I)
	obstacle\x 			= 320										; X POSITION ON SCREEN
	obstacle\y 			= 96										; Y POSITION ON SCREEN
	obstacle\SX 		= i + 3										; X SCREEN WHERE THE OBSTACLE WILL SPAWN
	obstacle\SY 		= i											; Y SCREEN WHERE THE OBSTACLE WILL SPAWN
	obstacle\image		= LoadImage("gfx/obstacle" + i + ".png")	; LOADS OBSTACLE GFX
Next




Repeat
	Cls
	
	
	Render()	; CALLS FUNCTION WHERE EVERYTHING IS RENDERED
	
	
	; THE FOLLOWING 8 CODE LINES USED TO BE IN A FUNCTION, BUT THAT COST 1 BYTE WHICH I DIDN'T HAVE ^^
	
	; THE FOLLOWING 4 CODE LINES HANDLE THE PLAYER MOVEMENT. THE MAP IS INFINITE LIKE THE EARTH. (IF YOU EXIT THE LAST SCREEN, YOU WILL RESPAWN ON THE FIRST SCREEN AND VICE VERSA)
	If playerX>616 Then playerX = 8   : Xscroll = (Xscroll + 1) Mod 9  										
	If playerX<8   Then playerX = 616 : Xscroll = (Xscroll - 1) Mod 9 : If Xscroll = -1 Then Xscroll = 8	
	If playerY>408 Then playerY = 8   : Yscroll = (Yscroll + 1) Mod 9										
	If playerY<8   Then playerY = 408 : Yscroll = (Yscroll - 1) Mod 9 : If Yscroll = -1 Then Yscroll = 8	
	
	; THE FOLLOWING 4 CODE LINES DEAL WITH PLAYER MOVEMENT. IF A MOVEMENT KEY IS PRESSED AND THERE'S NO WALL OR ANYTHING ELSE IN THE WAY, THE PLAYER WILL MOVE IN THAT DIRECTION
	; THE VALUE '20' IN THE NOWALL FUNCTION IS USED BECAUSE WITHOUT IT, THE FUNCTION WOULD FIND THE PLAYER'S OWN PIXELS AND WOULDN'T ALLOW HIM TO MOVE
	If KeyDown(205) And NoWall(20,0)  Then playerX = playerX + 4  											
	If KeyDown(203) And NoWall(-20,0) Then playerX = playerX - 4											
	If KeyDown(208) And NoWall(0,20)  Then playerY = playerY + 4											
	If KeyDown(200) And NoWall(0,-20) Then playerY = playerY - 4											
	
	
	Flip 1	; WOULD HAVE PREFERRED WAITTIMER + FLIP 0 COMBO, BUT I HAD NO BYTES LEFT Oo...
Until KeyHit(1)
End








Function NoWall(x%,y%)
	Local rgb%

	rgb = ReadPixel(playerX + x, playerY + y, BackBuffer())	; CHECK BACKBUFFER IF THE PATH IS CLEAR (NO WALL AND NO OBSTACLE)
	If rgb = -16777216 Then Return 1 						; -16777216 MEANS BLACK. PLAYER CAN MOVE :)
	
End Function



; THIS FUNCTION CHECKS FOR ITEMS AND OBSTACLES AND RENDERS EVERYTHING
Function Render()
	Local x%, y%, rgb%
	
	
	Color 0,0,$00CC44															; SET GREENISH COLOUR FOR WALLS
	
	; THIS LOOP READS ALL PIXEL DATA FROM THE CURRENT SCREEN AND CONVERTS EACH PIXEL WHICH IS NOT BLACK INTO A 64*48 GREENISH SPRITE
	For x=0 To 9																
		For y=0 To 8															
			rgb = ReadPixel(Xscroll*10 + x, Yscroll*9 + y, ImageBuffer(cave))	; READ PIXEL FROM CAVE.BMP
			If rgb <> -16777216 Then Rect x*64, y*48, 64, 48 					; IF PIXEL <> BLACK THEN DRAW 64*48 SPRITE
		Next
	Next
	
	
	; THIS LOOP RENDERS AN ITEM IF IT'S ON SCREEN OR IF IT'S IN THE PLAYER'S INVENTORY. IT ALSO CHECKS IF A PLAYER HAS FOUND AN ITEM AND ADDS IT TO THE INVENTORY.
	For item.TItem = Each TItem
		If item\SX = Xscroll And item\SY = Yscroll And item\owned = False		; ITEM ON CURRENT SCREEN AND PLAYER HASN'T FOUND IT YET?
			DrawImage item\image, item\x, item\y								; ...THEN RENDER IT
			item\owned = (Abs(playerX - item\x) + Abs(playerY - item\y)) < 50	; IF PLAYER NEAR ITEM, PICK IT UP
		EndIf
		If item\owned Then DrawImage item\image, 40*item\ID, 450				; IF ITEM IN INVENTORY, RENDER IT AT THE BOTTOM OF THE SCREEN
		
		; THIS SUB-LOOP RENDERS AN OBSTACLE IF IT'S ON SCREEN. IT ALSO CHECKS IF THE PLAYER CARRIES AN ITEM WHICH CAN DESTROY THE OBSTACLE
		For obstacle.TObstacle = Each TObstacle 											
			If obstacle\SX = Xscroll And obstacle\SY = Yscroll And obstacle\Destroyed = False	; OBSTACLE ON CURRENT SCREEN AND PLAYER HASN'T DESTROYED IT YET?
				DrawImage obstacle\image, obstacle\x, obstacle\y 								; ...THEN RENDER IT
				obstacle\Destroyed = (obstacle\beatenBy = item\ID And item\owned And Abs(playerX - obstacle\x) + Abs(playerY - obstacle\y)<95)	; DESTROY OBSTACLE IF PLAYER NEAR OBSTACLE AND IF PLAYER OWNS THE ITEM WHICH CAN DESTROY THE OBSTACLE
			EndIf
		Next
	Next
	
	DrawImage player, playerX-16, playerY-16				; RENDER PLAYER AT CORRECTED POSITION
	
	If Xscroll = 8 And Yscroll = 0 Then RuntimeError "YO"	; PLAYER FOUND EXIT? SHOW BEST ENDING SCREEN EVER ^^
	
End Function
;~IDEal Editor Parameters:
;~C#Blitz3D